#ifndef ALG_H
#define ALG_H

typedef struct alg_hash {
    int id;
    char *name;
    char sym[3];
    int len;
    int latency;
    void (* hash)(unsigned *, unsigned *);
    void (* pad)(int, unsigned *);
    void (* setbyte)(int, unsigned char, unsigned *);
    struct alg_hash *next;
} alg_hash;

alg_hash *alg_find_name(char *);
alg_hash *alg_find_id(int);
void alg_register(alg_hash *);

#endif
