#include <string.h>
#include "alg.h"
#include "sha1.h"
#include "md5.h"

static alg_hash *algs;

alg_hash *alg_find_name(char *name)
{
    alg_hash *i;
    for(i=algs; i; i=i->next)
	if(!strcmp(i->name, name))
	    return i;
    return NULL;
}
alg_hash *alg_find_id(int id)
{
    alg_hash *i;
    for(i=algs; i; i=i->next)
	if(i->id == id)
	    return i;
    return NULL;
}

void alg_register(alg_hash *alg)
{
    alg->next = algs;
    algs = alg;
}
